Page MenuHomePhabricator

test-copies: add test chaining multiple merges
ClosedPublic

Authored by marmoute on Dec 15 2020, 4:07 AM.

Details

Summary

Right now, the copy tracing logic take the right decision for merges, but it
does not keep track of the right information about these decision and can fall
into later traps. We start with highlighting this possibility by adding new
tests, and we will fix them later.

Check the inline test documentation for details.

Diff Detail

Repository
rHG Mercurial
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

marmoute created this revision.Dec 15 2020, 4:07 AM
baymax updated this revision to Diff 24372.Dec 17 2020, 4:04 PM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

baymax updated this revision to Diff 24399.Dec 18 2020, 9:12 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

baymax updated this revision to Diff 24406.Dec 18 2020, 9:31 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

baymax updated this revision to Diff 24414.Dec 18 2020, 9:54 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

baymax updated this revision to Diff 24452.Dec 21 2020, 3:00 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

pulkit added a subscriber: pulkit.Dec 28 2020, 3:32 AM
pulkit added inline comments.
tests/test-copies-chain-merge.t
1995

Shouldn't this and similar one above too be marked as known-bad-output?

marmoute added inline comments.Jan 5 2021, 2:50 AM
tests/test-copies-chain-merge.t
1995

Why should they be? This is the expected output for the filelog based logic.

pulkit added inline comments.Jan 5 2021, 2:53 AM
tests/test-copies-chain-merge.t
1995

I thought we can use known-bad-output for expected buggy output too.

marmoute added inline comments.Jan 5 2021, 2:58 AM
tests/test-copies-chain-merge.t
1995

The logic behind the filelog output is not "buggy" it simply use a different (more arbitrary) tie breaking mechanism that is stable regardless of the p1/p2 order. The behavior of the changeset centric algorithm is more "predictable", a hence a bit better in my opinion, however, the filelog one have been around since for-ever, so lets not touch it.

marmoute added inline comments.Jan 5 2021, 3:28 AM
tests/test-copies-chain-merge.t
1426

This comment is relevant to the conversation we are having.

baymax updated this revision to Diff 24568.Jan 5 2021, 3:37 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

baymax updated this revision to Diff 24591.Jan 5 2021, 9:01 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

Alphare accepted this revision.Jan 5 2021, 11:47 AM

Leather Motorcycle Jackets for Women
Find stylish motorcycle jackets for women at Wilsons Leather. Our collection feature quality leather moto jackets in a variety of colors and styles

Lucidchart Group Buy
is the best online graphing tool that makes drawing charts quick and easy. Quick flowcharts, company graphs, wireframes, UML, mind

marmoute retitled this revision from copies-test: add test chaining multiple merge to test-copies: add test chaining multiple merges.
marmoute updated this revision to Diff 25721.
baymax updated this revision to Diff 25762.Feb 22 2021, 11:34 AM

✅ refresh by Heptapod after a successful CI run (🐙 💚)

This revision was not accepted when it landed; it landed in state Needs Review.
This revision was automatically updated to reflect the committed changes.